package jp.agentec.sinaburocast.service;

import jp.agentec.sinaburocast.entity.AdminUser;
import jp.agentec.sinaburocast.entity.PointPeriod;

import org.seasar.framework.container.annotation.tiger.Component;
import org.seasar.framework.container.annotation.tiger.InstanceType;

@Component(instance=InstanceType.SINGLETON)
public class PointPeriodService extends AbstractService<PointPeriod> {

	public static final String ID_SEQ_NAME = "point_period_id_seq";

	/**
	 * IDを発行して、登録する。
	 */
	public int insertPointPeriod(PointPeriod pointPeriod, AdminUser adminUserInfo) {

		pointPeriod.pointPeriodId =
				getSeqNextVal(Integer.class, ID_SEQ_NAME);

		return super.insert(pointPeriod, adminUserInfo.loginId);
	}

	public PointPeriod findById(Integer pointPeriodId) {
        return select().id(pointPeriodId).getSingleResult();
    }
	
	
	public PointPeriod findByOnRecode() {
        return select().getSingleResult();
    }

}
