package jp.agentec.sinaburocast.service;

import javax.annotation.Resource;

import jp.agentec.sinaburocast.common.SinaburoConstant;
import jp.agentec.sinaburocast.entity.AdminUser;
import jp.agentec.sinaburocast.form.admin.setting.AdminRegistForm;
import jp.agentec.sinaburocast.form.admin.setting.AdminSearchForm;
import junit.framework.TestSuite;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.seasar.dao.unit.S2DaoTestCase;

public class AdminUserServiceTest extends S2DaoTestCase {

	@Resource
	private AdminUserService adminUserService;

	public AdminUserServiceTest(String string) {
		super(string);
	}

	public static TestSuite suite() {
		TestSuite suite = new TestSuite("AdminUserServiceTest");
		suite.addTest(new AdminUserServiceTest("findById"));
		suite.addTest(new AdminUserServiceTest("insertAdminUser"));
		suite.addTest(new AdminUserServiceTest("findByLoginId"));
		suite.addTest(new AdminUserServiceTest("findAllOrderById"));
		suite.addTest(new AdminUserServiceTest("findAllOrderByIdNotDel"));
		suite.addTest(new AdminUserServiceTest("findAllOrderByIdPaging"));
		suite.addTest(new AdminUserServiceTest("registOrUpdateAdminUser"));
		return suite;
	}


	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
        include("app.dicon");
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	public void findById() {
		System.out.println(adminUserService.findById(1));
	}

	public void insertAdminUser() {
    	AdminUser adminUserEntity=null;
		adminUserEntity = new AdminUser();
		adminUserEntity.loginId = "TESTTEST";
    	adminUserEntity.password  = "TESTTEST";
    	adminUserEntity.adminUserName  = "TESTTEST";
    	adminUserEntity.email  = "TESTTEST";
    	adminUserEntity.delFlg  = Integer.parseInt(SinaburoConstant.DelFlg.NOT_DEL);

		System.out.println(adminUserService.insertAdminUser(adminUserEntity,"TESTCLASS01"));
	}

	public void findByLoginId() {
		System.out.println(adminUserService.findByLoginId("TESTTEST11"));
	}

	public void findAllOrderById() {
		System.out.println(adminUserService.findAllOrderById());
	}

	public void findAllOrderByIdNotDel() {
		System.out.println(adminUserService.findAllOrderById());
	}

	public void findAllOrderByIdPaging() {
		String pageKey = null;
		Integer curPage = 1;
		AdminSearchForm adminSearchForm = new AdminSearchForm();
		System.out.println(adminUserService.findAllOrderByIdPaging(pageKey,curPage,adminSearchForm));
	}

	public void registOrUpdateAdminUser() {
		AdminRegistForm adminRegistForm = new AdminRegistForm();
		adminRegistForm.adminUserId = "50";
    	AdminUser adminUserEntity=null;
		adminUserEntity = new AdminUser();
		adminUserEntity.loginId =  "TESTCLASS01";
		adminRegistForm.loginId = "TESTTEST";
		adminRegistForm.password  = "TESTTEST";
		adminRegistForm.adminUserName  = "TESTTEST";
		adminRegistForm.email  = "TESTTEST";
		adminRegistForm.delFlg  = SinaburoConstant.DelFlg.NOT_DEL;

		System.out.println(adminUserService.registOrUpdateAdminUser(adminRegistForm,adminUserEntity));
	}
}
